Best method cplane to front while keeping views same?

Hi,
Tom, I have carefully followed your steps and here is the storyboard to prove it, reads from the top downward.
what I ended up with was not as per my mockup, but top was now front of tractor but tractor fallen over !, front was the left side as was right also the left side. Original perspective window which you didnt have me change was still not ‘mapped’ to wheel at all . Also the origin for what used to be top view, started at wheel centre after set Cplane to object was done but somehow changed, and as you can see it was nothing i did as that storyboard is every step captured !

If I clicked view front I then lose the Cplane so that didnt bring my front back either.

I then tried cplane former Front and got the front but no grid. try again for top and nothing happened.

Now could other folk follow Toms steps as I did and let me know if the outcome was the same ?
the rhino file crudetractor.3dm is earlier in the thread.

Here is what I got as a rhino file, after trying to get front back.
crude tractor uses Tom method for front nearside wheel try to get front and top as before.3dm (144.8 KB)

I see whilst doing this, Kev R has come up with a method.

I will try and follow that now.

I just wish one click of the wheel would make all views go like my mockup. I am sure others new to Rhino would expect that to happen as well.

Cplanes absolutely put the fear of god into me, not intuitive at all.

As my mockup is what folk would expect, some basic video out there on how to get this in as few steps as poss to those starting out with Rhino, would be most welcome to all, dare I speak for all ? …who’s brains work in a ‘what we would like and expect’ mode. Not all views madly changing, and even origins jumping about.

Steve

Looked at this further, and instead of trying to set up these CPlanes by using rotations of existing CPlanes it’s much easier to do it using the 3 Point option of the _CPlane command.

I will use the Perspective viewport to set-up and save all the CPlanes and then apply them to the other views.

First reset the Viewports and CPlanes:

_4Viewspace4Viewspace

Next, set the CPlane in the Perspective viewport using the Object option:

_Cplanespaceospaceclick front wheel

Now the CPlane in the the Perspective viewport should have it’s origin at the center of the front wheel, it’s X-Axis should be oriented towards the front of the wheel, and it’s Y-axis should be oriented towards the top of the wheel as shown here:

Note: I’m using an X-Ray display mode here with increased transparency to be able to better visualize the CPlane axis indicators.

This CPlane matches the orientation in the Perspective viewport in your “desired outcome” screenshot, so save it in the Named CPlanes panel with the name F-L_Wheel_Persp-View.

Now to set up the CPlane for the Top viewport we’ll be using the Center OSnap, Ortho mode, and Elevator Mode.

Elevator Mode may seem a bit tricky at first if you haven’t used it before, but it’s pretty easy once you’ve used it a few times. You start setting a point in Elevator Mode by positioning the mouse cursor at the point on the CPlane that is above (or below) where you want to place your point and making a control-click (Windows) or command-click (MacOS). You’ll then get the Elevator Mode indicator and you can position the mouse pointer above or below your anchor point and click to set your point.

Make sure the Center Osnap is active, I won’t be using any other OSnaps during this process.

Enable Ortho mode by clicking it in the status bar or by typing:
ospace

Start the CPlane command using the 3 Point option by typing:
_CPlanepspace

At the prompt for CPlane Origin, move the mouse pointer near the edge of the wheel until the Center Osnap activates and then click.

At the prompt for X-Axis Direction you’ll need to use Elevator Mode to place a point above the current CPlane. Move the mouse near the edge of the wheel until the Center Osnap activates then control-click (Windows) or command-click (MacOS) this will activate Elevator Mode. Position the mouse cursor at the outside of the wheel and you should see the red X-Axis indicator extending outward from the wheel. Move the mouse a short distance from the wheel and click to orient the X-Axis.

At the prompt for Y-Axis Direction, move the mouse pointer towards the back of the front wheel until the green Y-Axis indicator is oriented towards the back wheel and click.

The Perspective Viewport should now look like this:

Don’t worry if your result doesn’t match this the first time. You can restore the previous CPlane by double-clicking the saved CPlane named F-L_Wheel_Persp-view in the Named CPlanes panel and then try again.

When your view matches the picture above, save it with the name F-L_Wheel_Top-View in the Named CPlanes panel.

Now setting up the Front view CPlane, start the CPlane command using the 3 Point option by typing:
_CPlanepspace

At the prompt for CPlane Origin, move the mouse pointer near the edge of the wheel until the Center Osnap activates and then click.

At the prompt for X-Axis Direction position the mouse pointer at the outside of the wheel until the red X-Axis indicator is pointing outward then click.

At the prompt for Y-Axis Direction position the mouse pointer above the wheel until the green Y-Axis indicator is point upwards and click.

The viewport should now look like this:

Save this CPlane in the Named CPlanes panel with the name F-L_Wheel_Front-View

Now to set up the Right view CPlane start the _CPlane command using the 3 Point option by typing:
_CPlanepspace

At the prompt for CPlane Origin, move the mouse pointer near the edge of the wheel until the Center Osnap activates and then click.

At the prompt for X-Axis Direction position the mouse pointer at the rear of the wheel until the red X-Axis indicator is pointing towards the back wheel and click.

At the Y-Axis prompt, position the mouse above the wheel until the green Y-Axis indicator is pointing upward and click.

The viewport should now look like this:

Save this CPlane in the Named CPlanes panel with the name F-L_Wheel_Right-View

Now you can activate the saved CPlanes by dragging them from the Named CPlanes panel and dropping them in the corresponding viewports (or you can double-click each of the names of the custom CPlanes in the Saved CPlanes panel while the corresponding viewport is active).

You should also run the _Plan command while each of the Top, Front, and Right viewports are active to insure the views are aligned with the newly activated CPlanes.

The end result showing all viewports should look like this:

You can enable the display of the blue CPlane Z-Axis indicator by going to OptionsDisplay ModesShadedGridAdvanced grid settings and enabling Show Z-axis (or enabling this option for whatever display mode you’re using).

Seems like a long post, but if you work though this you’ll see that it isn’t too difficult or time consuming - you’ll get pretty fast at it after you do it a few times.

I’ve read though this a few times - if I’ve missed any typos or something doesn’t seem to work let me know and I’ll try to sort it out.

Here’s the updated file:
crude tractor_re_v5.3dm (119.5 KB)

Edit #1: Small change in wording to clarify.

Edit #2: Noticed that when I was creating the CPlane for the right view, I had clicked the center Osnap for the inside of the wheel instead of the outside (updated screen shot and 3dm file). Lesson learned - tumble model around to visually double check from multiple angles (especially if you’re doing this late at night).

Also worth noting that after defining the initial CPlane by using the Object option of the _CPlane command. When defining the CPlanes for the other views using the 3 Point option, at the first prompt (for CPlane Origin) you can just enter 0space since the origin is staying the same (probably less error prone).

-Kevin

MANY Thanks Kev R. FANTASTIC and really grateful, (will try it)
I will follow that and see what happens.
I still say, speaking out to all, and McNeel, that its unsettling and frustrating that its not possible in a click or two to get ones views looking like my mockup as beginners would expect. applying Cplane to the camber wheel and expecting other views to show that as well, in a couple of clicks.

I see with universal all views change, and with standard each view has to be changed one at a time.
Probably why I had Universal running, and just now on another job I found I wanted universal and that instant change to all views. My idea of a script and button to initiate would be good if we need to stay with standard to get this to work.

These steps are one of those one will need to recall, by printing them off and sticking them on the wall somewhere !

Could there be a script that does this, prompting each next stage with some text saying what to do next ? make a button for it, get it added into V5,6 and 7 ?

Steve

While looking into the possibilities of scripting this, I caught an error in the file I uploaded in my previous post (corrected and re-uploaded).

So far I’ve only created a very simple python script to display the properties of the saved CPlanes but it looks like it shouldn’t be too difficult to use one Cplane to derive the CPlanes for all the other views and save them.

This is the output from the script using the 3dm file I uploaded in my previous post:

As you can see from the output, the different views just have the axes flipped and/or reversed. If you have defined the CPlane for one view then the others can be calculated.

Here’s the python code to display the properties of the saved CPlanes if you’re interested:

Python Code
import Rhino

for pl in Rhino.RhinoDoc.ActiveDoc.NamedConstructionPlanes:
    print("Name: {0}".format(pl.Name))
    print("\tOrigin: {0:f6}".format(pl.Plane.Origin))
    print("\tX-Axis: {0:f6}".format(pl.Plane.XAxis))
    print("\tY-Axis: {0:f6}".format(pl.Plane.YAxis))
    print("\tZ-Axis: {0:f6}".format(pl.Plane.ZAxis))

-Kevin

Did you check the setting universal vs standard cplane ?
Screenshot 2021-12-04 at 13.39.38

Hi,
I am knowing how to make a button and add in a .py code, addressing it to where the code lives on my D drive.

If I make a button, how do I use that text that appears in your python code link ?

I have never taken text, always just downloaded a .py file from Pascal etc.

Once that text is the .py code in the button, will it be that I click the button and it takes me through the steps to get the view you and I post ?

This is a very significant Cplane command, useful to not just me. Wish I had had it since day 1.
needs to be available to all, Food4Rhino for example, or just added to Rhino upgrade.

Tom, I have it set to standard, were you aiming your question at me or Kev ?

Cheers

Steve

Info here to set up running scripts from buttons:
https://wiki.mcneel.com/rhino/macroscriptsetup

Here is a python file for the little script posted above:
named_cplane_properties.py (442 Bytes)

Also wanted to tell you that I noticed today that the hotkeys for the _CPlane command have changed from V5 to V7.

In the instructions I posted above, I wrote that to run the _CPlane command with the 3 Point> option to type:
_CPlanespacepspace

This works for V7 but for V5 you will need to type:
_CPlanespaceispace

I’ve also written a python script to save Named CPlans and Named Views.
customAxes.py (3.4 KB)

To use this script you need to define the CPlane for the top view of your desired coordinate system, save it in the Named CPlanes panel with a name that ends with "_top" (for example, name it “tractor_top”). Then run the script and it will create and save the other 5 Named Cplanes and 6 Named Views for your coordinate system.

Also worth noting, enabling Universal Construction Planes under OptionsModeling AidsSnaps automates part of this (I think that is why @Tom_P posted this info.). With this option set you can set the correct CPlane in the viewport for one of the standard views and it will create the CPlane in the other 2 standard views and swich them to a Plan view (looking down the Z-Axis). I don’t like having my views switch every time I define a CPlane so I keep this option set to Standard Construction Planes.

You can also get this same behavior by setting up a CPlane in one of the standard views and runnning the SynchronizeCPlanes command. In V7 if you select the Set View option it will update the standard views. In V5 the Set View option isn’t there but it always updates the views (so I guess you just cant set the CPlanes without also setting the Views).

-Kevin

Hi,
@kev.r
Kevin, (late getting back to this,) thank you for this, I must take a day out of life and create the button, and do all this.
Your screen shot of the result is what I wanted.
There is a lot there to take in.
Can the button make the Cplane standard or universal, whichever is neeeded to achieve this result, then allow user to set the Cplane in perspective view and the other views all become what I require.
All these options you then mention of synch planes, set view etc are clouding my brain a bit, easily done !

If you wish to summary this and show my original tractor, then the click of the button and the result, then the return to the default view, please do so.

to then have the script for the button , make one, and have that available would be great.

I need to turn win7 into win 10, install v7 then have that day.

I have just come across the need to place Cplane on an item I am desperately trying to finish so I can start the win 10 move, and needing to do so quickly, I will cheat and rotate the item and save it as a file just for the layout view !
That will be my wish since day 1 of Rhino come true. In fact anyone would wish for that, so all users would be happy I presume.
If your coding does all that, thank you in advance. Itching to make that button !

I need to try it to see what happens, in v7.

With 1.1k views clearly a lot of folk need this !

Steve